/*=========================================================================================================================
                                                                          
        ARTICLE: The Real Effects of FAS 166/167 on Banks Mortgage Approval and Sale Decisions                      
        AUTHORS: Yiwei Dou, Stephen G. Ryan, Biqin Xie                  
        JOURNAL OF ACCOUNTING RESEARCH 

 		The code below obtains from Call Report the matching between a commercial bank id and the id of its parent BHC.

 ==========================================================================================================================*/


/*==================================================
obtain from Call Report the matching between a commercial bank id and the id of its parent BHC
/*==================================================*/

/*maco to import call report data prior to 2011 into sas*/
%macro drive(dir,ext,out);                                                                                                                                                                                                                                         
  %let filrf=mydir;                                                                                                                      
  /* Assigns the fileref of mydir to the directory and opens the directory */                                                                    
  %let rc=%sysfunc(filename(filrf,&dir));                                                                                                
  %let did=%sysfunc(dopen(&filrf));                                                                                                      

  /* Returns the number of members in the directory */                                                                   
  %let memcnt=%sysfunc(dnum(&did));                                                                                                      

   /* Loops through entire directory */                                                                                                  
   %do i = 1 %to &memcnt;                                                                                                                
     /* Returns the extension from each file */                                                                                                                                    
     %let name=%qscan(%qsysfunc(dread(&did,&i)),-1,.);               
 
     /* Checks to see if file contains an extension */                                                                                     
	%if %qupcase(%qsysfunc(dread(&did,&i))) ne %qupcase(&ext) %then %do;                                                                  

     /* Checks to see if the extension matches the parameter value */                                                                      
     /* If condition is true, submit PROC COPY statement  */                                                                      

     %if (%superq(ext) ne and %qupcase(&name) = %qupcase(&ext)) or                                                                       
         (%superq(ext) = and %superq(name) ne) %then %do;                                                            
          libname old xport "&dir.\%qsysfunc(dread(&did,&i))"; 
            libname new "&out";
            proc copy in=old out=new;
            run;
     %end;                                                                                                                               
   %end; 
  %end; 

  /* Close the directory */                                                                                                            
  %let rc=%sysfunc(dclose(&did));                                                                                                        
/* END MACRO */                                                                                                                                           

%mend drive;   
 
/* Macro call */
/*First parameter is the source folder, the second parameter is extension being searched for, and the third parameter is the target directory for the converted files*/
 
%drive(c:\documents and settings\,xpt,c:\)

%drive(M:\My Documents\bxie,xpt,M:\My Documents\bxie\);

/*convert 2011-2014 structure data of call reports into sas format*/
%drive(F:\bxie,xpt,F:\bxie\);


libname sec 'F:\bxie'; run;


%macro keep(data);
data sec.&data._keep; set sec.&data;
	if RSSD9348~=0 then rssdhh=RSSD9348;
	if RSSD9348=0 and RSSD9364~=0 then rssdhh=RSSD9364;
	if RSSD9348=0 and RSSD9364=0 then rssdhh=.;
	keep RSSD9001 RSSD9050 RSSD9055 
	RSSD9348 RSSD9364 RSSD9365 RCON9999 RSSDHH;
run;
%mend keep;

%keep(call0412); 
%keep(call0512); 
%keep(call0612); 
%keep(call0712); 
%keep(call0812); 
%keep(call0912); 
%keep(call1012); 

%macro keep(data);
data sec.&data._keep; set sec.&data;
	if RSSD9348~=0 then rssdhh=RSSD9348;
	if RSSD9348=0 and RSSD9364~=0 then rssdhh=RSSD9364;
	if RSSD9348=0 and RSSD9364=0 then rssdhh=.;
	keep RSSD9001 RSSD9050 RSSD9055 
	RSSD9348 RSSD9364 RSSD9365 RCON9999 RSSDHH;
run;
%mend keep;

%keep(call1112); 
%keep(call1212); 
%keep(call1312); 
%keep(call1412); 



%macro conv(year);
data sec.call&year.12_keep; set sec.call&year.12_keep;
year=20&year; run;
proc means; run;
%mend conv; 

%conv(04); 
%conv(05); 
%conv(06); 
%conv(07); 
%conv(08); 
%conv(09); 
%conv(10); 

*reanme the datasets;
proc datasets library=sec;
   change call9612_keep=call1996_keep call9712_keep=call1997_keep call9812_keep=call1998_keep call9912_keep=call1999_keep call0012_keep=call2000_keep 
   call0112_keep=call2001_keep call0212_keep=call2002_keep call0312_keep=call2003_keep call0412_keep=call2004_keep 
   call0512_keep=call2005_keep call0612_keep=call2006_keep call0712_keep=call2007_keep call0812_keep=call2008_keep call0912_keep=call2009_keep call1012_keep=call2010_keep
   ;
run; *these datasets contain the matching between the id of a commercial bank from call reports and the ID of its parent BHC;



